﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using EssentialTools2.Models;

namespace EssentialTools2.Controllers
{
    /// <summary>
    /// 控制器：要先实例化计算器类，再把计算器类作参数带入购物车类的构造器中，然后调用购物车类的方法
    /// </summary>
    public class HomeController : Controller
    {
        private Product[] products={
                                                new Product{Name="Kayak",Category="Watersports",Price=275m},
                                                new Product{Name="Lifejacket",Category="Watersports",Price=48.95m},
                                                new Product{Name="Soccer ball",Category="Soccer",Price=19.50m},
                                                new Product{Name="Corner flag",Category="Soccer",Price=34.95m}
                                              };
        
        private IValueCalculator calc;
        //添加一个构造器，接受IValueCalculator接口的实现
        public HomeController(IValueCalculator calcParam) { 
            calc=calcParam;
        }
        public HomeController() { }
        public ActionResult Index()
        {
            ShoppingCart shoppingCart = new ShoppingCart(calc) { 
                Products=products
            };
            decimal result = shoppingCart.CalculateProductTotal();
            return View(result);
        }
    }
}
